javax.persistence

## Interface EntityManager

    public interface EntityManager

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `clear()`
`void` `close()`
`boolean` `contains(Object entity)`
`Query` `createNamedQuery(String name)`
`<T> TypedQuery<T>` `createNamedQuery(String name, Class<T> resultClass)`
`Query` `createNativeQuery(String sqlString)`
`Query` `createNativeQuery(String sqlString, Class resultClass)`
`Query` `createNativeQuery(String sqlString, String resultSetMapping)`
`<T> TypedQuery<T>` `createQuery(CriteriaQuery<T> criteriaQuery)`
`Query` `createQuery(String qlString)`
`<T> TypedQuery<T>` `createQuery(String qlString, Class<T> resultClass)`
`void` `detach(Object entity)`
`<T> T` `find(Class<T> entityClass, Object primaryKey)`
`<T> T` `find(Class<T> entityClass, Object primaryKey, LockModeType lockMode)`
`<T> T` `find(Class<T> entityClass, Object primaryKey, LockModeType lockMode, Map<String,Object> properties)`
`<T> T` `find(Class<T> entityClass, Object primaryKey, Map<String,Object> properties)`
`void` `flush()`
`CriteriaBuilder` `getCriteriaBuilder()`
`Object` `getDelegate()`
`EntityManagerFactory` `getEntityManagerFactory()`
`FlushModeType` `getFlushMode()`
`LockModeType` `getLockMode(Object entity)`
`Metamodel` `getMetamodel()`
`Map<String,Object>` `getProperties()`
`<T> T` `getReference(Class<T> entityClass, Object primaryKey)`
`EntityTransaction` `getTransaction()`
`boolean` `isOpen()`
`void` `joinTransaction()`
`void` `lock(Object entity, LockModeType lockMode)`
`void` `lock(Object entity, LockModeType lockMode, Map<String,Object> properties)`
`<T> T` `merge(T entity)`
`void` `persist(Object entity)`
`void` `refresh(Object entity)`
`void` `refresh(Object entity, LockModeType lockMode)`
`void` `refresh(Object entity, LockModeType lockMode, Map<String,Object> properties)`
`void` `refresh(Object entity, Map<String,Object> properties)`
`void` `remove(Object entity)`
`void` `setFlushMode(FlushModeType flushMode)`
`void` `setProperty(String propertyName, Object value)`
`<T> T` `unwrap(Class<T> cls)`

### Method Detail

#### persist

    void persist(Object entity)

#### merge

    <T> T merge(T entity)

#### remove

    void remove(Object entity)

#### find

    <T> T find(Class<T> entityClass,
               Object primaryKey)

#### find

    <T> T find(Class<T> entityClass,
               Object primaryKey,
               Map<String,Object> properties)

#### find

    <T> T find(Class<T> entityClass,
               Object primaryKey,
               LockModeType lockMode)

#### find

    <T> T find(Class<T> entityClass,
               Object primaryKey,
               LockModeType lockMode,
               Map<String,Object> properties)

#### getReference

    <T> T getReference(Class<T> entityClass,
                       Object primaryKey)

#### flush

    void flush()

#### setFlushMode

    void setFlushMode(FlushModeType flushMode)

#### getFlushMode

    FlushModeType getFlushMode()

#### lock

    void lock(Object entity,
              LockModeType lockMode)

#### lock

    void lock(Object entity,
              LockModeType lockMode,
              Map<String,Object> properties)

#### refresh

    void refresh(Object entity)

#### refresh

    void refresh(Object entity,
                 Map<String,Object> properties)

#### refresh

    void refresh(Object entity,
                 LockModeType lockMode)

#### refresh

    void refresh(Object entity,
                 LockModeType lockMode,
                 Map<String,Object> properties)

#### clear

    void clear()

#### detach

    void detach(Object entity)

#### contains

    boolean contains(Object entity)

#### getLockMode

    LockModeType getLockMode(Object entity)

#### setProperty

    void setProperty(String propertyName,
                     Object value)

#### getProperties

    Map<String,Object> getProperties()

#### createQuery

    Query createQuery(String qlString)

#### createQuery

    <T> TypedQuery<T> createQuery(CriteriaQuery<T> criteriaQuery)

#### createQuery

    <T> TypedQuery<T> createQuery(String qlString,
                                  Class<T> resultClass)

#### createNamedQuery

    Query createNamedQuery(String name)

#### createNamedQuery

    <T> TypedQuery<T> createNamedQuery(String name,
                                       Class<T> resultClass)

#### createNativeQuery

    Query createNativeQuery(String sqlString)

#### createNativeQuery

    Query createNativeQuery(String sqlString,
                            Class resultClass)

#### createNativeQuery

    Query createNativeQuery(String sqlString,
                            String resultSetMapping)

#### joinTransaction

    void joinTransaction()

#### unwrap

    <T> T unwrap(Class<T> cls)

#### getDelegate

    Object getDelegate()

#### close

    void close()

#### isOpen

    boolean isOpen()

#### getTransaction

    EntityTransaction getTransaction()

#### getEntityManagerFactory

    EntityManagerFactory getEntityManagerFactory()

#### getCriteriaBuilder

    CriteriaBuilder getCriteriaBuilder()

#### getMetamodel

    Metamodel getMetamodel()